#include <windows.h>
#include <shlwapi.h>

#ifndef _DEBUG
extern "C"
int _fltused = 1;
#endif

// ---------------- ev ----------------

// DWORD
__inline
DWORD TamperDword(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr = target;
	return old;
}

// DWORDZ
__inline
DWORD TamperDwordAdd(DWORD addr, DWORD delta)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr += delta;
	return old;
}

// NEAR JMPIyh
__inline
DWORD TamperJump(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)(addr + 1) + (addr + 5);
	*(DWORD*)(addr + 1) = target - (addr + 5);
	return old;
}

// tHgfBXNv^
#pragma pack(push, 4)
struct SWRFONTDESC {
	char FaceName[0x100];
	BYTE R1;
	BYTE R2;
	BYTE G1;
	BYTE G2;
	BYTE B1;
	BYTE B2;
	LONG Height;
	LONG Weight;
	BYTE Italic;
	BYTE Shadow;
	BYTE UseOffset;
	DWORD BufferSize;
	DWORD OffsetX;
	DWORD OffsetY;
	DWORD CharSpaceX;
	DWORD CharSpaceY;
};

// RpNg
struct SWRSTR {
	union {
		char  str[16];
		char* pstr;
	};
	size_t length;

	operator char *() {
		return length > 15 ? pstr : str;
	}
};

// GtFNg}l[WC^[tF[X
struct IEffectManager {
	virtual void* Destruct(int dynamic) = 0;
	virtual void LoadPattern(LPCSTR fileName, int) = 0;
	virtual void ClearPattern() = 0;
	virtual void AppendRegion(int arg_0, float arg_4, float arg_8, char arg_c, char arg_10, int arg_14) = 0;
	virtual void ClearRegion() = 0;
};

// 悭킩Ȃ
struct UnknownF {
	void *Unknown[3];
	float Aaxis;
	float Baxis;
};

// static_assert
template<bool value>
struct static_assert { typedef struct assert_failed Type; };
template<>
struct static_assert<true> { typedef void* Type; };

// union_cast
template<typename TDest, typename TSrc>
__forceinline 	
TDest union_cast(TSrc src) {
	static_assert<sizeof(TDest) == sizeof(TSrc)>::Type 
		size_mismatch = 0;
	union {  TDest dst; TSrc src; } c;
	c.src = src;
	return c.dst;
}

// thiscall
class C {};
#define Ccall(p,f,r,T) (((C*)p)->*union_cast<r##(C::*)##T>(f))

// tHgIuWFNg\bh
#define SWRFont_Create(p) \
	Ccall(p,0x410D30,void,())()
#define SWRFont_Destruct(p) \
	Ccall(p,0x410DC0,void,())()
#define SWRFont_SetIndirect(p, pdesc) \
	Ccall(p,0x410EA0,void,(void*))(pdesc)

// eNX`}l[W\bh
#define CTextureManager_CreateTextTexture(p, ret, str, pdesc ,width ,height) \
	Ccall(p,0x405270,int*,(int*, LPCSTR, void*, int, int))(ret, str, pdesc, width, height)
#define CTextureManager_LoadTexture(p, ret, path, unk1, unk2) \
	Ccall(p,0x405200,int*,(int*, LPCSTR, void*, void*))(ret, path, unk1, unk2)
#define CTextureManager_SetTexture(p, id, stage) \
	Ccall(p,0x405360,void,(int, int))(id, stage)
#define CTextureManager_GetSize(p, w, h) \
	Ccall(p,0x4053D0,void,(int*, int*))(w, h)
#define CTextureManager_Remove(p, id) \
	Ccall(p,0x4052E0,void*,(int))(id)
// eNX`}l[W\bh(nh}l[W̌p)
#define CTextureManager_Get(p, id) \
	((IDirect3DTexture9**)CHandleManager_Get(p, id))
#define CTextureManager_Allocate(p, id) \
	((IDirect3DTexture9**)CHandleManager_Allocate(p, id))
#define CTextureManager_Deallocate(p, id) \
	CHandleManager_Deallocate((void *)p, id)

// nh}l[W\bh
#define CHandleManager_Get(t, p, id) \
	Ccall(p,0x402800,t*,(int))(id)
 __declspec(naked) void**
Thunk_CHandleManager_Allocate(void *p, int *ret) {
	// thiscallȂ̂ɗƎvedigĂł@̊
	__asm push edi
	__asm mov edi, [esp+8]
	__asm push [esp+12]
	__asm mov eax, 0x402690
	__asm call eax
	__asm pop edi
	__asm retn
 }
#define CHandleManager_Allocate(p, ret) \
	Thunk_CHandleManager_Allocate(p, ret)
 __declspec(naked) void
Thunk_CHandleManager_Deallocate(void *p, int id) {
	 // thiscall()eaxgĂł@̊
	__asm mov eax, [esp+4]
	__asm push [esp+8]
	__asm mov ecx, 0x402660
	__asm call ecx
	__asm retn
 }
#define CHandleManager_Deallocate(p, id) \
	Thunk_CHandleManager_Deallocate(p, id)

// _\bh
#define CRenderer_Begin(p)  \
	Ccall(p,0x401000,bool,())()
#define CRenderer_End(p) \
	Ccall(p,0x401040,void,())()

// ZNgGtFNg}l[W\bh
#define CSelectEffectManager_Create(p) \
	Ccall(p, 0x4212E0, void, ())()

// Cvbg}l[W\bh
#define CInputManager_ReadReplay(p, name) \
	Ccall(p, 0x42BF80, bool,(char *))(name)

// xN^IuWFNg
#define Vector_Create \
	((void (__stdcall *)(void *, size_t, size_t, int, int))0x68624C)
#define Vector_Destruct \
	((void (__stdcall *)(void *, size_t, size_t, int))0x6861E9)

// VXeL[Vbg
#define CheckKeyOneshot  \
 	((bool(*)(int, int, int, int))0x439FE0)

// pbg[h
#define LoadPackagePalette(pflag, name, pal, bpp) \
	Ccall(pflag, 0x409070, void, (LPCSTR, void *, int))(name, pal, bpp)

// LN^̎擾
#define GetCharacterAbbr \
	((LPCSTR (__cdecl *)(int id))0x43B460)

// og[hݒ
#define SetBattleMode \
	((void (__cdecl *)(int comm, int sub))0x43ADA0)

// eNX`}l[W
// CHandleManager<IDirect3DTexture *>
#define g_textureMgr ((void *)0x6F7D40)
// Direct3DfoCX
// IDirect3DDevice9*
#define g_pd3dDev    (*((IDirect3DDevice9**)0x6F8250))
// _
// CRenderer
#define g_renderer   ((void *)0x6EEDBC)
// lbg[NIuWFNg
// CNetworkServer/CNetworkClient
#define g_pnetObject (*(char**)0x6F12FC)
// vt@C
// char *
#define g_pprofP1 ((char*)(g_pnetObject + 0x04))
#define g_pprofP2 ((char*)(g_pnetObject + 0x24))
// UDPlbg[NIuWFNg
// CNetworkBase
#define g_pnetUdp    (g_pnetObject + 0x3B4)
// sA
// vector<SWRClientInfo> ?
#define g_psvClients (g_pnetUdp + 0xFC)
// T[oAhX
// in_addr
#define g_ptoAddr    (g_pnetUdp + 0x2C)
// og}l[W
// CBattleManager *
#define g_pbattleMgr (*(void **)0x6F1244)
// CtH}l[W
// CInfoManager *
#define g_pinfoMgr   (*(void **)0x6F1248)
// [h
// int
#define g_commMode   (*(DWORD*)0x6F12EC)
#define g_subMode    (*(DWORD*)0x6F12E4)
#define g_menuMode   (*(DWORD*)0x6DB94C)
// V[ID
// DWORD
#define g_sceneId    (*(DWORD*)0x6F7E7C)
// Ro[gf[^ptO
// bool
#define g_useCVxData (*(bool*)0x6F7E80)
// pbgIuWFNg
// void *
#define g_paletter   (*(void **)0x6EEDF8)
// Cvbg}l[W
// CInputManager ?
#define g_inputMgr   ((void *)0x6F1370)
// Cvbg}l[WNX^
// CInputManagerCluster
#define g_inputMgrs  ((void *)0x6F2520)
// LN^ID
// int
#define g_leftCharID (*(int*)0x006F1FF0)
#define g_rightCharID (*(int*)0x006F2010)
// argc/argv
#define __argc       (*(int*)0x6F2988)
#define __argv       (*(char***)0x6F298C)

// z֐e[u
#define vtbl_CLogo              0x6B76FC
#define vtbl_Opening            0x6B7798
#define vtbl_CTitle             0x6B7CF4
#define vtbl_CSelect            0x6B7BCC
#define vtbl_CLoading           0x6B76AC
#define vtbl_CBattle            0x6B7470
#define vtbl_CSelectCL          0x6B7504
#define vtbl_CLoadingCL         0x6B7524
#define vtbl_CBattleCL          0x6B7540
#define vtbl_CSelectSV          0x6B74AC
#define vtbl_CLoadingSV         0x6B74CC
#define vtbl_CBattleSV          0x6B74E8
#define vtbl_CLoadingWatch      0x6B7E68
#define vtbl_CBattleWatch       0x6B755C
#define vtbl_CBattleManager     0x6B850C

// ZNVTCY
#define text_Offset  0x401000
#define text_Size    0x2B6000
#define rdata_Offset 0x6B72D4
#define rdata_Size   0x23D2C

// ---------------- ܂Ńev ----------------


#define CSelectSV_Create(p) \
	Ccall(p, s_origCSelectSV_Create, void, ())()
#define CSelectSV_Render(p) \
	Ccall(p, s_origCSelectSV_Render, int, ())()
#define CSelectCL_Create(p) \
	Ccall(p, s_origCSelectCL_Create, void, ())()
#define CSelectCL_Render(p) \
	Ccall(p, s_origCSelectCL_Render, int, ())()
#define CSelect_Create(p) \
	Ccall(p, s_origCSelect_Create, void, ())()
#define CSelect_Render(p) \
	Ccall(p, s_origCSelect_Render, int, ())()
#define CSelect_Destruct(p) \
	Ccall(p, s_origCSelect_Destruct, void, ())()

#define Hiiro_LoadPalette \
	((bool (*)(void *pal, int id, int set, int offset))((char *)s_hHiiro + 0x1310))

static HMODULE s_hHiiro;
static BYTE s_paletteIdMap[2][15];

static DWORD s_origCSelectSV_Create;
static DWORD s_origCSelectSV_Render;
static DWORD s_origCSelectCL_Create;
static DWORD s_origCSelectCL_Render;
static DWORD s_origCSelect_Create;
static DWORD s_origCSelect_Render;
static DWORD s_origCSelect_Destruct;
static DWORD s_origCSelect_Size;

void CSelect_ReloadSelectStandEffect(void *This, int id, int set, int offset)
{
	char buff[260];
	// ܂1PWpbg[h(paletterƐݒ肳悤ɁB)
	wsprintf(buff, "data/scene/select/character/%s/palette%03d.bmp",
		GetCharacterAbbr(id), 0);
	LoadPackagePalette(&g_useCVxData, buff, &g_paletter, 0x10);

	char *palbuff = *(char **)(&g_paletter + 1);
	if(set == 99) {
		// _̓VGbgɂႤ
		WORD *wpalbuff = (WORD *)palbuff;
		for(int i = 0; i < 256; ++i)
			wpalbuff[i] &= 0x8000;
	} else
	// Fpbg[hā`
	if(Hiiro_LoadPalette(palbuff, id, set, 0xFFFFFFFF))
	{
		// XNuāAƁB
		for(int i = 0; i < 0x200; ++i)
			palbuff[i] ^= 0xFF;
	}

	// ׂ
	IEffectManager *em = (IEffectManager*)
		((char*)This + offset + id * 0x94 * 2);
	em->Destruct(0);
	CSelectEffectManager_Create(em);

	// L̗p^[[h
	wsprintf(buff, "data/scene/select/character/%s/stand.pat",
		GetCharacterAbbr(id));
	em->LoadPattern(buff, 0);
	// 1PGtFNg
	float Baxis = (*(UnknownF**)((char*)This + 0x604))->Baxis + 8.0f;
	float Aaxis = (*(UnknownF**)((char*)This + 0x604))->Aaxis + 32.0f; 
	em->AppendRegion(0, Aaxis, Baxis, 1, 0, 0);
	// 2PGtFNg
	Baxis = (*(UnknownF**)((char*)This + 0x608))->Baxis + 8.0f;
	Aaxis = (*(UnknownF**)((char*)This + 0x608))->Aaxis + 32.0f; 
	em->AppendRegion(0, Aaxis, Baxis, 1, 1, 0);
}

void * __fastcall CSelectCommon_OnCreate(void *This)
{

	// 2PGZbg
	char *p2Effect = (char *)This + s_origCSelect_Size;
	Vector_Create(p2Effect, 0x94, 0x1E, 0x4212E0, 0x422980);

	char buff[260];
	for(int i = 0; i < 15; ++i) {
		// 1Ppbg[h
		wsprintf(buff, "data/scene/select/character/%s/palette%03d.bmp",
			GetCharacterAbbr(i), 0);
		LoadPackagePalette(&g_useCVxData, buff, &g_paletter, 0x10);

		// L̗p^[[h
		wsprintf(buff, "data/scene/select/character/%s/stand.pat",
			GetCharacterAbbr(i));
		IEffectManager *em = (IEffectManager *)(p2Effect + i * 0x94 * 2);
		em->LoadPattern(buff, 0);
		// 1PGtFNg
		float Baxis = (*(UnknownF**)((char*)This + 0x604))->Baxis + 8.0f;
		float Aaxis = (*(UnknownF**)((char*)This + 0x604))->Aaxis + 32.0f; 
		em->AppendRegion(0, Aaxis, Baxis, 1, 0, 0);
		// 2PGtFNg
		Baxis = (*(UnknownF**)((char*)This + 0x608))->Baxis + 8.0f;
		Aaxis = (*(UnknownF**)((char*)This + 0x608))->Aaxis + 32.0f; 
		em->AppendRegion(0, Aaxis, Baxis, 1, 1, 0);
	}

	// F`H
	s_hHiiro = GetModuleHandle("papp.dll");

	// pbgID}bv
	memset(s_paletteIdMap, 0, sizeof(s_paletteIdMap));

	return This;
}

void * __fastcall CSelectSV_OnCreate(void *This)
{
	// super
	CSelectSV_Create(This);
	return CSelectCommon_OnCreate(This);
}

void * __fastcall CSelectCL_OnCreate(void *This)
{
	// super
	CSelectCL_Create(This);
	return CSelectCommon_OnCreate(This);
}

void * __fastcall CSelect_OnCreate(void *This)
{
	// super
	CSelect_Create(This);
	return CSelectCommon_OnCreate(This);
}

void __fastcall CSelect_OnDestruct(void *This)
{
	// 2PGZbĝĂ
	char *p2Effect = (char *)This + s_origCSelect_Size;
	Vector_Destruct(p2Effect, 0x94, 0x1E, 0x422980);

	// super
	CSelect_Destruct(This);

}

void __fastcall CSelectCommon_OnRender(void *This)
{
	// FAݒɏ]ăJpς
	if(s_hHiiro) {
		int p1set = *(char*)((char *)s_hHiiro + 0x3188);
		if(
		g_leftCharID != 0xF &&
		s_paletteIdMap[0][g_leftCharID] != p1set) {
			s_paletteIdMap[0][g_leftCharID] = p1set;
			CSelect_ReloadSelectStandEffect(
				This, g_leftCharID, p1set, 0x7FC);
		}
		int p2set = *(char*)((char *)s_hHiiro + 0x3189);
		if(
		g_rightCharID != 0xF &&
		s_paletteIdMap[1][g_rightCharID] != p2set) {
			s_paletteIdMap[1][g_rightCharID] = p2set;
			CSelect_ReloadSelectStandEffect(
				This, g_rightCharID, p2set, s_origCSelect_Size);
		}
	}
}

int __fastcall CSelectSV_OnRender(void *This)
{
	// super
	int ret = CSelectSV_Render(This);
	CSelectCommon_OnRender(This);
	return ret;
}

int __fastcall CSelectCL_OnRender(void *This)
{
	// super
	int ret = CSelectCL_Render(This);
	CSelectCommon_OnRender(This);
	return ret;
}

int __fastcall CSelect_OnRender(void *This)
{
	// super
	int ret = CSelect_Render(This);
	CSelectCommon_OnRender(This);
	return ret;
}

void __declspec(naked) CSelect_OnChangeCharacter()
{
	__asm {
		test edi, edi
		jnz p2
p1:		lea eax, [esi+ebp+7FCh]
		jmp ep
p2:		mov eax, s_origCSelect_Size
		lea eax, [esi+eax]
		lea eax, [ebp+eax]
ep:		push 0x41F5F0
		retn
	}
}

BOOL Hook()
{
	// 
	DWORD old;
	::VirtualProtect((PVOID)text_Offset, text_Size, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCSelect_Size = max(*(DWORD*)0x41DABD, *(DWORD*)0x41DC4D);
	s_origCSelect_Size = max(s_origCSelect_Size, *(DWORD*)0x41DBA2);
	*(DWORD*)0x41DABD = s_origCSelect_Size + 0x94 * 0x1E;
	*(DWORD*)0x41DC4D = s_origCSelect_Size + 0x94 * 0x1E;
	*(DWORD*)0x41DBA2 = s_origCSelect_Size + 0x94 * 0x1E;

	s_origCSelectSV_Create = TamperJump(
		0x41DBC4, union_cast<DWORD>(CSelectSV_OnCreate));
	s_origCSelectCL_Create = TamperJump(
		0x41DC6F, union_cast<DWORD>(CSelectCL_OnCreate));
	s_origCSelect_Create = TamperJump(
		0x41DADF, union_cast<DWORD>(CSelect_OnCreate));

	// SĂSelectĂ̂ł̒RXg̕
	s_origCSelect_Destruct = TamperJump(
		0x423E83, union_cast<DWORD>(CSelect_OnDestruct));

	// ΂́cc
	*(BYTE*) 0x41F5E9 = 0xe9;
	TamperJump(0x41F5E9, union_cast<DWORD>(CSelect_OnChangeCharacter));
	::VirtualProtect((PVOID)text_Offset, text_Size, old, &old);

	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCSelectSV_Render = TamperDword(
		vtbl_CSelectSV + 0x08, union_cast<DWORD>(CSelectSV_OnRender));
	s_origCSelectCL_Render = TamperDword(
		vtbl_CSelectCL + 0x08, union_cast<DWORD>(CSelectCL_OnRender));
	s_origCSelect_Render = TamperDword(
		vtbl_CSelect + 0x08, union_cast<DWORD>(CSelect_OnRender));
	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, old, &old);

	::FlushInstructionCache(GetCurrentProcess(), NULL, 0);
	return TRUE;
}

extern "C"
int APIENTRY DllMain(HMODULE hModule, DWORD fdwReason, LPVOID lpReserved)
{
	return (fdwReason == DLL_PROCESS_ATTACH) ? Hook() : TRUE;
}
