#include <windows.h>
#include <mmsystem.h>
#include <shlwapi.h>
#include <d3d9.h>

#pragma comment(lib, "shlwapi.lib")
#pragma comment(lib, "winmm.lib")


// ---------------- ev ----------------

// DWORD
__inline
DWORD TamperDword(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr = target;
	return old;
}

// DWORDZ
__inline
DWORD TamperDwordAdd(DWORD addr, DWORD delta)
{
	DWORD old = *(DWORD*)addr;
	*(DWORD*)addr += delta;
	return old;
}

// NEAR JMPIyh
__inline
DWORD TamperJump(DWORD addr, DWORD target)
{
	DWORD old = *(DWORD*)(addr + 1) + (addr + 5);
	*(DWORD*)(addr + 1) = target - (addr + 5);
	return old;
}

// tHgfBXNv^
#pragma pack(push, 4)
struct SWRFONTDESC {
	char FaceName[0x100];
	BYTE R1;
	BYTE R2;
	BYTE G1;
	BYTE G2;
	BYTE B1;
	BYTE B2;
	LONG Height;
	LONG Weight;
	BYTE Italic;
	BYTE Shadow;
	BYTE UseOffset;
	DWORD BufferSize;
	DWORD OffsetX;
	DWORD OffsetY;
	DWORD CharSpaceX;
	DWORD CharSpaceY;
};

// RpNg
struct SWRSTR {
	union {
		char  str[16];
		char* pstr;
	};
	size_t length;

	operator char *() {
		return length > 15 ? pstr : str;
	}
};

// GtFNg}l[WC^[tF[X
struct IEffectManager {
	virtual void* Destruct(int dynamic) = 0;
	virtual void LoadPattern(LPCSTR fileName, int) = 0;
	virtual void ClearPattern() = 0;
	virtual void AppendRegion(int arg_0, float arg_4, float arg_8, char arg_c, char arg_10, int arg_14) = 0;
	virtual void ClearRegion() = 0;
};

// 悭킩Ȃ
struct UnknownF {
	void *Unknown[3];
	float Aaxis;
	float Baxis;
};

// static_assert
template<bool value>
struct static_assert { typedef struct assert_failed Type; };
template<>
struct static_assert<true> { typedef void* Type; };

// union_cast
template<typename TDest, typename TSrc>
__forceinline 	
TDest union_cast(TSrc src) {
	static_assert<sizeof(TDest) == sizeof(TSrc)>::Type 
		size_mismatch = 0;
	union {  TDest dst; TSrc src; } c;
	c.src = src;
	return c.dst;
}

// thiscall
class C {};
#define Ccall(p,f,r,T) (((C*)p)->*union_cast<r##(C::*)##T>(f))

// tHgIuWFNg\bh
#define SWRFont_Create(p) \
	Ccall(p,0x410D30,void,())()
#define SWRFont_Destruct(p) \
	Ccall(p,0x410DC0,void,())()
#define SWRFont_SetIndirect(p, pdesc) \
	Ccall(p,0x410EA0,void,(void*))(pdesc)

// eNX`}l[W\bh
#define CTextureManager_CreateTextTexture(p, ret, str, pdesc ,width ,height) \
	Ccall(p,0x405270,int*,(int*, LPCSTR, void*, int, int))(ret, str, pdesc, width, height)
#define CTextureManager_LoadTexture(p, ret, path, unk1, unk2) \
	Ccall(p,0x405200,int*,(int*, LPCSTR, void*, void*))(ret, path, unk1, unk2)
#define CTextureManager_SetTexture(p, id, stage) \
	Ccall(p,0x405360,void,(int, int))(id, stage)
#define CTextureManager_GetSize(p, w, h) \
	Ccall(p,0x4053D0,void,(int*, int*))(w, h)
#define CTextureManager_Remove(p, id) \
	Ccall(p,0x4052E0,void*,(int))(id)
// eNX`}l[W\bh(nh}l[W̌p)
#define CTextureManager_Get(p, id) \
	((IDirect3DTexture9**)CHandleManager_Get(p, id))
#define CTextureManager_Allocate(p, id) \
	((IDirect3DTexture9**)CHandleManager_Allocate(p, id))
#define CTextureManager_Deallocate(p, id) \
	CHandleManager_Deallocate((void *)p, id)

// nh}l[W\bh
#define CHandleManager_Get(t, p, id) \
	Ccall(p,0x402800,t*,(int))(id)
 __declspec(naked) void**
Thunk_CHandleManager_Allocate(void *p, int *ret) {
	// thiscallȂ̂ɗƎvedigĂł@̊
	__asm push edi
	__asm mov edi, [esp+8]
	__asm push [esp+12]
	__asm mov eax, 0x402690
	__asm call eax
	__asm pop edi
	__asm retn
 }
#define CHandleManager_Allocate(p, ret) \
	Thunk_CHandleManager_Allocate(p, ret)
 __declspec(naked) void
Thunk_CHandleManager_Deallocate(void *p, int id) {
	 // thiscall()eaxgĂł@̊
	__asm mov eax, [esp+4]
	__asm push [esp+8]
	__asm mov ecx, 0x402660
	__asm call ecx
	__asm retn
 }
#define CHandleManager_Deallocate(p, id) \
	Thunk_CHandleManager_Deallocate(p, id)

// _\bh
#define CRenderer_Begin(p)  \
	Ccall(p,0x401000,bool,())()
#define CRenderer_End(p) \
	Ccall(p,0x401040,void,())()

// ZNgGtFNg}l[W\bh
#define CSelectEffectManager_Create(p) \
	Ccall(p, 0x4212E0, void, ())()

// Cvbg}l[W\bh
#define CInputManager_ReadReplay(p, name) \
	Ccall(p, 0x42BF80, bool,(char *))(name)

// xN^IuWFNg
#define Vector_Create \
	((void (__stdcall *)(void *, size_t, size_t, int, int))0x68624C)
#define Vector_Destruct \
	((void (__stdcall *)(void *, size_t, size_t, int))0x6861E9)

// VXeL[Vbg
#define CheckKeyOneshot  \
 	((bool(*)(int, int, int, int))0x439FE0)

// pbg[h
#define LoadPackagePalette(pflag, name, pal, bpp) \
	Ccall(pflag, 0x409070, void, (LPCSTR, void *, int))(name, pal, bpp)

// LN^̎擾
#define GetCharacterAbbr \
	((LPCSTR (__cdecl *)(int id))0x43B460)

// og[hݒ
#define SetBattleMode \
	((void (__cdecl *)(int comm, int sub))0x43ADA0)

// eNX`}l[W
// CHandleManager<IDirect3DTexture *>
#define g_textureMgr ((void *)0x6F7D40)
// Direct3DfoCX
// IDirect3DDevice9*
#define g_pd3dDev    (*((IDirect3DDevice9**)0x6F8250))
// _
// CRenderer
#define g_renderer   ((void *)0x6EEDBC)
// lbg[NIuWFNg
// CNetworkServer/CNetworkClient
#define g_pnetObject (*(char**)0x6F12FC)
// vt@C
// char *
#define g_pprofP1 ((char*)(g_pnetObject + 0x04))
#define g_pprofP2 ((char*)(g_pnetObject + 0x24))
// UDPlbg[NIuWFNg
// CNetworkBase
#define g_pnetUdp    (g_pnetObject + 0x3B4)
// sA
// vector<SWRClientInfo> ?
#define g_psvClients (g_pnetUdp + 0xFC)
// T[oAhX
// in_addr
#define g_ptoAddr    (g_pnetUdp + 0x2C)
// og}l[W
// CBattleManager *
#define g_pbattleMgr (*(void **)0x6F1244)
// CtH}l[W
// CInfoManager *
#define g_pinfoMgr   (*(void **)0x6F1248)
// [h
// int
#define g_commMode   (*(DWORD*)0x6F12EC)
#define g_subMode    (*(DWORD*)0x6F12E4)
#define g_menuMode   (*(DWORD*)0x6DB94C)
// V[ID
// DWORD
#define g_sceneId    (*(DWORD*)0x6F7E7C)
// Ro[gf[^ptO
// bool
#define g_useCVxData (*(bool*)0x6F7E80)
// pbgIuWFNg
// void *
#define g_paletter   (*(void **)0x6EEDF8)
// Cvbg}l[W
// CInputManager ?
#define g_inputMgr   ((void *)0x6F1370)
// Cvbg}l[WNX^
// CInputManagerCluster
#define g_inputMgrs  ((void *)0x6F2520)
// argc/argv
#define __argc       (*(int*)0x6F2988)
#define __argv       (*(char***)0x6F298C)

// z֐e[u
#define vtbl_CLogo              0x6B76FC
#define vtbl_Opening            0x6B7798
#define vtbl_CTitle             0x6B7CF4
#define vtbl_CSelect            0x6B7BCC
#define vtbl_CLoading           0x6B76AC
#define vtbl_CBattle            0x6B7470
#define vtbl_CSelectCL          0x6B7504
#define vtbl_CLoadingCL         0x6B7524
#define vtbl_CBattleCL          0x6B7540
#define vtbl_CSelectSV          0x6B74AC
#define vtbl_CLoadingSV         0x6B74CC
#define vtbl_CBattleSV          0x6B74E8
#define vtbl_CLoadingWatch      0x6B7E68
#define vtbl_CBattleWatch       0x6B755C
#define vtbl_CBattleManager     0x6B850C

// ZNVTCY
#define text_Offset  0x401000
#define text_Size    0x2B6000
#define rdata_Offset 0x6B72D4
#define rdata_Size   0x23D2C

// ---------------- ܂Ńev ----------------

// ZNg
#define CSelectSV_Create(p) \
	Ccall(p, s_origCSelectSV_Create, void*, ())()
#define CSelectSV_Render(p) \
	Ccall(p, s_origCSelectSV_Render, int, ())()
#define CSelectSV_Destruct(p, dyn) \
	Ccall(p, s_origCSelectSV_Destruct, void*, (int))(dyn)
#define CSelectCL_Create(p) \
	Ccall(p, s_origCSelectCL_Create, void*, ())()
#define CSelectCL_Render(p) \
	Ccall(p, s_origCSelectCL_Render, int, ())()
#define CSelectCL_Destruct(p, dyn) \
	Ccall(p,s_origCSelectCL_Destruct,void*, (int))(dyn)

static char s_profilePath[1024 + MAX_PATH];
static int s_seq = 1;
static int s_lastip = -1;

struct SWRVERTEX
{
	float x, y, z;
	float rhw;
	D3DCOLOR color;
	float u, v;
};

#define FVF_SWRVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)

static DWORD s_origCSelectSV_Create;
static DWORD s_origCSelectSV_Render;
static DWORD s_origCSelectSV_Destruct;
static DWORD s_origCSelectCL_Create;
static DWORD s_origCSelectCL_Render;
static DWORD s_origCSelectCL_Destruct;
static DWORD s_origCSelect_Size;

void * __fastcall CSelectCommon_OnCreate(void *This)
{
	int &m_texID = *(int *)((char *)This + s_origCSelect_Size + 0x00);

	// ip
	int newip;
	switch(g_commMode) {
	case 4: // 
		newip = *(int*)(*(char**)g_psvClients + 4);
		break;
	case 5: // 
		newip = *(int*)(g_ptoAddr + 4);
		break;
	}
	if(s_lastip != newip) {
		s_lastip = newip;
		s_seq = 1;
	}

	// TEh
	char soundPath[1025];
	char keyName[16];
	::wsprintf(keyName, "%d", s_seq);
	if(GetPrivateProfileString("Sound", keyName, "", soundPath, _countof(soundPath), s_profilePath)) {
		::PlaySound(soundPath, NULL, SND_FILENAME | SND_NOWAIT);
	}
	
	// VeNX`
	char font[0x1A4]; // Ƃ 0x1A4
	SWRFont_Create(font);

	SWRFONTDESC sfdesc;
	strcpy(sfdesc.FaceName, "lr SVbN");
	sfdesc.R1 = 0xFF;
	sfdesc.R2 = 0xA0;
	sfdesc.G1 = 0xFF;
	sfdesc.G2 = 0xA0;
	sfdesc.B1 = 0xFF;
	sfdesc.B2 = 0xFF;
	sfdesc.Height = 0x20;
	sfdesc.Weight = 300;
	sfdesc.Italic = 0;
	sfdesc.Shadow = 1;
	sfdesc.UseOffset = 0;
	sfdesc.BufferSize = 100000;
	sfdesc.OffsetX = 0;
	sfdesc.OffsetY = 0;
	sfdesc.CharSpaceX = 0;
	sfdesc.CharSpaceY = 2;
	SWRFont_SetIndirect(font, &sfdesc);

	char dispString[64];
	::wsprintf(dispString, "%d", s_seq++);
	CTextureManager_CreateTextTexture(g_textureMgr, &m_texID, dispString, font, 200, 50);
	
	SWRFont_Destruct(font);

	return This;
}

void * __fastcall CSelectSV_OnCreate(void *This)
{
	// super
	CSelectSV_Create(This);
	return CSelectCommon_OnCreate(This);
}

void * __fastcall CSelectCL_OnCreate(void *This)
{
	// super
	CSelectCL_Create(This);
	return CSelectCommon_OnCreate(This);
}

void __fastcall CSelectCommon_OnRender(void *This)
{
	int &m_texID = *(int *)((char *)This + s_origCSelect_Size + 0x00);

	if(CRenderer_Begin(g_renderer)) {
		// CSpriteɔCĂ񂾂ǁA܂łD
		static const SWRVERTEX vertices[] = {
			{ 0.0f,    0.0f, 0.0f, 1.0f, 0xffffffff, 0.0f, 0.0f },
			{ 200.0f,  0.0f, 0.0f, 1.0f, 0xffffffff, 1.0f, 0.0f },
			{ 200.0f, 50.0f, 0.0f, 1.0f, 0xffffffff, 1.0f, 1.0f },
			{ 0.0f,   50.0f, 0.0f, 1.0f, 0xffffffff, 0.0f, 1.0f },
		};
		static const SWRVERTEX vertices2[] = {
			{ 0.0f,    0.0f, 0.0f, 1.0f, 0x60000000, 0.0f, 0.0f },
			{ 200.0f,  0.0f, 0.0f, 1.0f, 0x60000000, 1.0f, 0.0f },
			{ 200.0f, 40.0f, 0.0f, 1.0f, 0x60000000, 1.0f, 1.0f },
			{ 0.0f,   40.0f, 0.0f, 1.0f, 0x60000000, 0.0f, 1.0f },
		};

		CTextureManager_SetTexture(g_textureMgr, NULL, 0);
		g_pd3dDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, vertices2, sizeof(SWRVERTEX));

		CTextureManager_SetTexture(g_textureMgr, m_texID, 0);
		g_pd3dDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, vertices, sizeof(SWRVERTEX));

		CRenderer_End(g_renderer);
	}
}

int __fastcall CSelectSV_OnRender(void *This)
{
	// super
	int ret = CSelectSV_Render(This);
	CSelectCommon_OnRender(This);
	return ret;
}

int __fastcall CSelectCL_OnRender(void *This)
{
	// super
	int ret = CSelectCL_Render(This);
	CSelectCommon_OnRender(This);
	return ret;
}

void __fastcall CSelectCommon_OnDestruct(void *This)
{
	int &m_texID = *(int *)((char *)This + s_origCSelect_Size + 0x00);
	CTextureManager_Remove(g_textureMgr, m_texID);

}

void * __fastcall CSelectSV_OnDestruct(void *This, int, int dyn)
{
	CSelectCommon_OnDestruct(This);
	return CSelectSV_Destruct(This, dyn);
}

void * __fastcall CSelectCL_OnDestruct(void *This, int, int dyn)
{
	CSelectCommon_OnDestruct(This);
	return CSelectCL_Destruct(This, dyn);
}

BOOL Hook(HMODULE hModule)
{

	GetModuleFileName(hModule, s_profilePath, 1024);
	PathRemoveFileSpec(s_profilePath);
	PathAppend(s_profilePath, "NetBattleCounter.ini");

	// 
	DWORD old;
	::VirtualProtect((PVOID)text_Offset, text_Size, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCSelect_Size = max(*(DWORD*)0x41DC4D, *(DWORD*)0x41DBA2);
	*(DWORD*)0x41DC4D = s_origCSelect_Size + 4;
	*(DWORD*)0x41DBA2 = s_origCSelect_Size + 4;

	s_origCSelectSV_Create = 
		TamperJump(0x41DBC4, union_cast<DWORD>(CSelectSV_OnCreate));
	s_origCSelectCL_Create =
		TamperJump(0x41DC6F, union_cast<DWORD>(CSelectCL_OnCreate));
	::VirtualProtect((PVOID)text_Offset, text_Size, old, &old);

	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCSelectSV_Destruct = 
		TamperDword(vtbl_CSelectSV + 0x00, union_cast<DWORD>(CSelectSV_OnDestruct));
	s_origCSelectSV_Render = 
		TamperDword(vtbl_CSelectSV + 0x08, union_cast<DWORD>(CSelectSV_OnRender));
	s_origCSelectCL_Destruct = 
		TamperDword(vtbl_CSelectCL + 0x00, union_cast<DWORD>(CSelectCL_OnDestruct));
	s_origCSelectCL_Render =
		TamperDword(vtbl_CSelectCL + 0x08, union_cast<DWORD>(CSelectCL_OnRender));
	::VirtualProtect((PVOID)rdata_Offset, rdata_Size, old, &old);

	::FlushInstructionCache(GetCurrentProcess(), NULL, 0);
	return TRUE;
}

extern "C"
int APIENTRY DllMain(HMODULE hModule, DWORD fdwReason, LPVOID lpReserved)
{
	return (fdwReason == DLL_PROCESS_ATTACH) ? Hook(hModule) : TRUE;
}
